Foreman - Bug #4731

Creating domain when organization selected produces duplicate key error
03/19/2014 08:31 PM - Ivan Necas

Status: Closed

Priority: High

Assignee: Joseph Magen

Category: Database

Target version: 1.5.0

Difficulty: Fixed in Releases:
Triaged: Found in Releases:
Bugzilla link: 1079999 Red Hat JIRA:

Pull request:

Description

1. choose organization
2. create new domain

Expected:

new domain created

Current:

Warning!

ERROR: duplicate key value violates unigque constraint "domains_pkey"
Notice:

When no org is selected, it works without issues

Related issues:

Related to Foreman - Bug #4932: Creating Compute Resource results in DB error Duplicate 03/28/2014
Related to Foreman - Bug #16389: Can't create taxable e.g. domain object if I... Closed 08/31/2016
Has duplicate Foreman - Bug #4729: Importing subnet fails on unknown attribute Duplicate 03/19/2014

Associated revisions

Revision 3c4051e9 - 03/31/2014 01:05 PM - Joseph Magen

fixes #4731 - Rails 3.2.8 causing _pkey constraint errors

History

#1 - 03/19/2014 08:31 PM - lvan Necas

- Description updated

#2 - 03/19/2014 09:51 PM - Ivan Necas
- Priority changed from Normal to High

Similar issue happens, when trying to create new provisioning template inside an org:

ERROR: duplicate key value violates unique constraint "config_templates_pkey"

#3 - 03/20/2014 08:30 AM - Dominic Cleal

- Category set to Database

Occurs on PostgreSQL, not SQLite.

It looks like the ID is generated in the SQL instead of using a sequence, which ends up with a duplicate? In this example, | already had a single
domain with ID=1, added a second (foo.example.com) within an org/loc context and the same ID was assigned.

SQL (2.2ms) INSERT INTO "domains" ("created_at", "dns_id", "fullname", "hostgroups_count", "hosts_count", "
id", "name", "updated_at") VALUES ($1, $2, $3, $4, $5, $6, $7, $8) RETURNING "id" [["created_at", Thu, 20 Mar
2014 08:24:47 UTIC +00:00], ["dns_id", nil], ["fullname", ""]1, ["hostgroups_count", 0], ["hosts_count", 01, ["

id", 11, ["name", "foo.example.com"], ["updated_at", Thu, 20 Mar 2014 08:24:47 UTC +00:001]]
PGError: ERROR: duplicate key value violates unique constraint "domains_pkey"
INSERT INTO "domains" ("created_at", "dns_id", "fullname", "hostgroups_count", "hosts_count", "id", "name",
"updated_at") VALUES ($1, $2, $3, $4, $5, $6, $7, $8) RETURNING "id"
(0.1ms) ROLLBACK
Operation FAILED: ERROR: duplicate key value violates unique constraint "domains_pkey"

/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapters/postgresql_a
dapter.rb:1171:in “get_last_result'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapters/postgresqgl_a
dapter.rb:1171:in "~exec_cache'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapters/postgresqgl_a
dapter.rb:665:in “block in exec_query'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapters/abstract_ada
pter.rb:280:in "block in log'
/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/notifications/instrumenter.rb:
20:in " instrument'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapters/abstract_ada
pter.rb:275:in "~ log'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapters/postgresql_a
dapter.rb:663:in "“exec_query'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapters/abstract/dat
abase_statements.rb:63:in “exec_insert'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapters/abstract/dat
abase_statements.rb:90:in "~ insert'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapters/abstract/que
ry_cache.rb:14:in “insert'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/lib/active_record/relation.rb:66:in "insert'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/persistence.rb:366:in "create'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/timestamp.rb:57:in ‘create'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/callbacks.rb:268:in “block in cr
eate'
/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:403:in " _run__ 383
7851857623516097__create__137576595651868549__callbacks'
/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:405:in '__run_cal
lback'
/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:385:in '_run_crea
te_callbacks'
/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:81:in "run_callba
cks'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/callbacks.rb:268:1in " create'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/persistence.rb:347:in " create_or
_update'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/callbacks.rb:264:in "block in cr
eate_or_update'
/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:425:in ' _run__ 383
7851857623516097__save_ 137576595651868549___callbacks'
/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:405:in "__run_cal
lback'
/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:385:in '_run_save
_callbacks'
/opt/rh/rubyl93/root/usr/share/gems/gems/activesupport-3.2.8/1lib/active_support/callbacks.rb:81:in “run_callba
cks'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/callbacks.rb:264:in ‘create_or_u
pdate'’
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/persistence.rb:84:in " save'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/validations.rb:50:in "save'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/attribute_methods/dirty.rb:22:1in
“save'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/transactions.rb:241:in “block (2
levels) in save'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/transactions.rb:295:in “block in
with_transaction_returning_status'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/connection_adapters/abstract/dat
abase_statements.rb:192:in "transaction'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/transactions.rb:208:in 'transact
ion'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/transactions.rb:293:in “with_tra
nsaction_returning_status'
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/transactions.rb:241:in “block in
save'

/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/transactions.rb:252:in 'rollback
_active_record_state!"
/opt/rh/rubyl93/root/usr/share/gems/gems/activerecord-3.2.8/1lib/active_record/transactions.rb:240:1in " save'
/usr/share/foreman/app/controllers/domains_controller.rb:16:in ‘create'

#4 - 03/24/2014 01:39 PM - Dominic Cleal
Likely the same as https://bugzilla.redhat.com/show_bug.cgi?id=1079999

#5 - 03/28/2014 02:38 AM - Mike McCune

is there a workaround for this? It is pretty fatal for getting much of anything done with upstream and downstream builds.

#6 - 03/28/2014 02:39 AM - Mike McCune

looks like if you have Any Org selected it works fine. duh

#7 - 03/28/2014 02:47 AM - Mike McCune

also perhaps related to:

http://projects.theforeman.org/issues/4932

#8 - 03/28/2014 08:20 AM - Dominic Cleal
- Related to Bug #4932: Creating Compute Resource results in DB error added

#9 - 03/30/2014 07:20 AM - Joseph Magen
- Status changed from New to Assigned

- Assignee set to Joseph Magen

#10 - 03/30/2014 08:36 AM - Joseph Magen
- Status changed from Assigned to Ready For Testing

https://github.com/theforeman/foreman/pull/1337

#11 - 03/30/2014 08:49 AM - Ohad Levy

how was the initial database created? was it using plain install, or rather prod2dev rake task?

#12 - 03/30/2014 08:50 AM - Ohad Levy

or rather this is a db restore?
#13 - 03/30/2014 04:16 PM - Justin Sherrill
The db is created using the normal installer(s). | am able to reproduce on the nightly foreman installation with orgs and locations enabled. The rake

task solution is not appropriate as the assumed cause is not true.

#14 - 03/30/2014 04:32 PM - Justin Sherrill

Note that the error only occurs upon creation of the 2nd domain and an org needs to be selected during the creation of both.

#15 - 03/31/2014 01:29 AM - Justin Sherrill

Also, only seems to occur with Rails 3.2.8 even in development (3.2.8 is currently used in production)

#16 - 03/31/2014 07:24 AM - Dominic Cleal
- Status changed from Ready For Testing to Assigned

Maybe this should be filed against RHSCL if the Rails fix can be identified.

#17 - 03/31/2014 08:53 AM - Ohad Levy
- Target version set to 1.8.4

- translation missing: en.field_release set to 9

#18 - 03/31/2014 09:17 AM - Dominic Cleal
https://bugzilla.redhat.com/show_bug.cgi?id=1079999
http://projects.theforeman.org/issues/4932
https://github.com/theforeman/foreman/pull/1337

- Status changed from Assigned to Ready For Testing

https://github.com/theforeman/foreman/pull/1339

#19 - 03/31/2014 11:55 AM - Dominic Cleal
- Bugzilla link set to https://bugzilla.redhat.com/show_bug.cgi?id=1079999

#20 - 03/31/2014 12:03 PM - Dominic Cleal
- Has duplicate Bug #4729: Importing subnet fails on unknown attribute added

#21 - 03/31/2014 01:31 PM - Joseph Magen
- Status changed from Ready For Testing to Closed
- % Done changed from 0 to 100

Applied in changeset 3c4051e93e20ed228c70b6eca74c7d4007901e12.

#22 - 04/18/2014 01:40 AM - Dominic Cleal

- translation missing: en.field_release changed from 9 to 4

#23 - 08/31/2016 05:25 AM - Marek Hulan

- Related to Bug #16389: Can't create taxable e.g. domain object if I'm in context of specific organization or location added
